// Cjpeg.h
//
// 

#ifndef CJPEG_H
#define CJPEG_H

#include <jpeglib.h>
#include <jerror.h>

#define CJPEG_ERROR     -1
#define CJPEG_SUCCESS   0

#define GRAYSCALE 1
#define COLOR_RGB 3

#define DEFAULT_QUALITY 80

class Cjpeg {
    
    public:
        Cjpeg();
        ~Cjpeg();
        
        int readJPEG(char *jpgFileName);
        unsigned int getWidth();
        unsigned int getHeight();
        unsigned int getColorChannel();
        unsigned long getFrameSize();
        unsigned long getImgSize();

        int writeJPEG(char *jpgFileName);
        void setImgSize(unsigned int width, unsigned int height,
                        unsigned int colorChannel);
        void setQuality(unsigned int quality);
        void setProgressive();
        void setRestartMarkers(int i);
        int exportRGB(double *R, double *G, double *B);
        int importRGB(double *R, double *G, double *B);

        JSAMPLE *imgBuf;
        
    private:
        unsigned int width;
        unsigned int height;
        unsigned int quality;
        unsigned int progressive;
        int restartMarkers;
        unsigned int colorChannel;
        J_COLOR_SPACE colorSpace;
        unsigned long frameSize;
        unsigned long imgSize;

    protected:
};

#endif
