#include <stdio.h>
#include <stdlib.h>
#include "Cjpeg.h"

int main(int argc, char *argv[])
{
    // check command line options
    if (argc!=3) {
        fprintf(stderr, "ex in.jpg out.jpg");
        exit(1);
    }

    // create JPEG object
    Cjpeg img;

    // set input jpeg file name
    // img.jpgFileName = argv[1];

    // read the input jpeg file
    // if ( img.readJPEG() != CJPEG_SUCCESS ) {
    //    fprintf(stderr, "jpeg read error!\n");
    //    exit(1);
    // }

    // image is stored in img.imgBuf[]
    // you can get the image information by calling the member functions
    // getWidth, getHeight, getColorChannel, getFrameSize, getImgSize
    // "frameSize" is the physical size of the image.
    // "imgSize" is the size of the memory to store the image.
    // imgSize = frameSize * colorChannel (for gray images they are equal)


    // set quality (1-100)
    img.setQuality(10);

    // call setProgressive if we want progressive JPEG image
    img.setProgressive();

    int width, height, colorChannel;
    width = 227;
    height = 149;
    colorChannel = 3;
    img.setImgSize(width, height, colorChannel);

    double *R = new double [width*height];
    double *G = new double [width*height];
    double *B = new double [width*height];
    long i;
    for (i=0;i<width*height;i++) {
        R[i] = 125;
        G[i] = 24;
        B[i] = 33;
    }
    
    img.importRGB(R, G, B);
    
    // write the output JPEG image file
    img.writeJPEG(argv[2]);

    delete [] R;
    delete [] G;
    delete [] B;
    
    return(0);
}
